/****************************************************************/
/*                                                              */
/*  IBM Confidential                                            */
/*  OCO Source Materials                                        */
/*  Component IBM Rational ROSE_RT TARGET_RTS : ROSE_RT         */
/*   Copyright IBM Corp. [1998], [2004] .All Rights Reserved.  */
/*                                                              */
/*  The source code for this program is not published or        */
/*  or otherwise divested of its trade secrets, irrespective    */
/*  of what has been deposited with the U.S. Copyright Office.  */
/*                                                              */
/****************************************************************/

#include <RTAsciiDecoding.h>
#include <RTObject_class.h>

int RTAsciiDecoding::get_indirect( void                 * pointer,
				   const RTObject_class * target )
{
    int     status = 1;
    void ** link   = (void **)pointer;
    void  * value  = (void  *)0;
    void  * trash  = (void  *)0;

    if( getFieldListStart() == 0 )
    {
		int tag;

		if( get_int( tag ) == 0 || tag != 0 ) 
		{
			char byte;
			get_char(byte);

			if(byte != '\0')
				status = 0;
		}
    }
    else if( (value = target->allocate()) != (void *)0 )
    {
	target->init( value );

	if( target->decode( value, this ) == 0 )
	    status = 0;

	if( getFieldListFinish() == 0 )
	    status = 0;
    }

    if( status == 0 )
	trash = value;
    else
    {
	trash = *link;
	*link = value;
    }

    if( trash != (void *)0 )
	target->destroy( trash, RTObject_class::DestroyAndDeallocate );

    return status;
}
